/**
 * @file Main.cpp
 * @date 2016-08-03
 */

// Copyright (C) 2016 Usagi
// Licensed under the MIT License.

// for Siv3D March 2016

#define USESKIN (0)


// 0: 0iA1: 1iA2: c[
#define NODESTRUCT (1)

// WɃO[oł͂Ȃ[JWli[邩ǂ
#define USELOCAL (0)


#include "modelconvertergpb.hpp"
#include "gpb.hpp"

#include "HamFramework\\SceneManager.hpp"

#define FSL L"Large"
#define FSM L"Medium"
#define FSS L"Small"

#define AXISH (0.25)
#define AXISI (50.0)

/// <summary>ŜŎgp</summary>
struct Data {
	/// <summary>GUIz</summary>
	Array<GUI> guis;
	/// <summary>^C}[</summary>
	Stopwatch timerMilli;

	/// <summary>ϊѕ`p</summary>
	Array<ModelConverterGpb> converters;
	/// <summary>CX^X1</summary>
	Array<MotionInstance> mis;

	/// <summary>]</summary>
	double ang = 0;
	/// <summary>ݒUI</summary>
	bool uiVisibled[4];

	/// <summary>bZ[Wp</summary>
	Effect effect;

//// J
/// <summary>}EXʒu</summary>
	Optional<Point> prePos;

	/// <summary>J</summary>
	Vec3 basePYR = { 0.5236, -s3d::Math::HalfPi + 0.5236,0 };
	/// <summary>ZoJ</summary>
	Vec3 curPYR = { 0.5236, -s3d::Math::HalfPi + 0.5236,0 };
	/// <summary>J̋</summary>
	double camDist = 1500.0 - 1000.0;


	/// <summary>{^̗LZbg</summary>
	void btMake(bool enabled) {
		guis[0].button(L"bt_make").enabled = enabled;
	}
};

using MyApp = ham::SceneManager<String,Data>;

/// <summary>bZ[W\</summary>
struct Message : IEffect {
	String msg;
	/// <summary>YW</summary>
	int my = 100;
	/// <summary>RXgN^</summary>
	Message(String inMsg) {
		msg = inMsg;
	}
	/// <summary>XV</summary>
	bool update(double t) override {
		double alpha = 1.0;
		if (t < 1.0) {
			alpha = t;
		}
		else if (t > 4.0) {
			alpha = 5.0 - t;
		}
		ColorF c0(Palette::White,alpha);
		ColorF c1(Palette::Black,alpha);

		int y = my - (int)Math::Floor(t*20);

		FontAsset(FSS)(msg).drawCenter(y+2, c1);
		FontAsset(FSS)(msg).drawCenter(y, c0);
		return t < 5.0;
	}
};

/// <summary>X^[gAbv</summary>
struct Startup : MyApp::Scene {
	/// <summary></summary>
	void init() override {
		FontAsset::Register(FSL, 48, Typeface::Black, FontStyle::Outline);
		FontAsset::Register(FSM, 32, Typeface::Black, FontStyle::Outline);
		FontAsset::Register(FSS, 16, Typeface::Black, FontStyle::Outline);

		FontAsset(FSL).changeOutlineStyle({ Palette::Midnightblue, Palette::Whitesmoke, 3 });
		FontAsset(FSM).changeOutlineStyle({ Palette::Black, Palette::White, 2 });
		FontAsset(FSS).changeOutlineStyle({ Palette::Black, Palette::White, 1 });


		Window::SetTitle(L"^p .mqo.gpbϊ 3");
		Window::SetStyle(WindowStyle::Sizeable);
		Dragdrop::SetEnabled(true);

		Window::Resize({800,600});

		Camera cam = Graphics3D::GetCamera();
		cam.lookat = { 0, 0, 0 };
		Graphics3D::SetCamera(cam);

		m_data->timerMilli.start();

// CݒGUI
		GUI gui(GUIStyle::Default);
		gui.setTitle(L"ݒ");

		gui.add(L"tx_fps", GUIText::Create(L"-"));
		gui.add(GUIText::Create(L"fps"));
		gui.add(GUIText::Create(L"JE^"));
		gui.addln(L"tx_counter", GUIText::Create(L"-"));

		gui.addln(L"bt_open1", GUIButton::Create(L"͐ݒ"));
		gui.addln(L"bt_open2", GUIButton::Create(L"vr[ݒ"));
		gui.addln(L"bt_open3", GUIButton::Create(L"o͐ݒ"));

		gui.add(GUIHorizontalLine::Create());

		gui.addln(L"rb_deci", GUIRadioButton::Create({ L"10{", L"1{", L"0.1{" },1u));

		gui.add(L"bt_open", GUIButton::Create(L"J"));
		gui.addln(L"bt_clear", GUIButton::Create(L"NA"));

		gui.add(GUIHorizontalLine::Create());

		gui.addln(L"bt_make", GUIButton::Create(L"gpbo"));

		Rect rc = gui.getRect();
		gui.setPos(Window::Width() - rc.w - 4, Window::Height() - rc.h - 4);
		gui.hide();

		m_data->guis.push_back(gui);
		m_data->btMake(false);

// IvVUI
		GUI gui1(GUIStyle::Default);
		gui1.setTitle(L"͐ݒ");
		gui1.addln(L"cb_dblface", GUICheckBox::Create({ L"ʑfނ͖ʒǉɂ" }));

		gui1.add(GUIHorizontalLine::Create());

		gui1.addln(GUIText::Create(L"ʕ"));
		Optional<uint32> checkItem = { 2u };
		gui1.addln(L"rb_cutting", GUIRadioButton::Create({ L"P(y)",L"I",L"ˉe(d)" }, checkItem));

		gui1.setPos(4, 4);
		gui1.hide();
		m_data->guis.push_back(gui1);

// ^
		GUI gui2(GUIStyle::Default);
		gui2.setTitle(L"vr[ݒ");

		gui2.add(GUIText::Create(L"ӏƖ"));
		gui2.add(L"sl_amb", GUISlider::Create(0, 100, 50));
		gui2.addln(L"tx_amb", GUIText::Create(L"0.50"));
		Graphics3D::SetAmbientLight(ColorF(0.50));

		gui2.add(L"cb_axis", GUICheckBox::Create({ L"Obh\" }, { 0 }));
		gui2.addln(L"bt_bgc", GUIButton::Create(L"wiF"));

		gui2.add(L"cb_wire", GUICheckBox::Create({ L"C[t[\" }));
		gui2.addln(L"cb_rot", GUICheckBox::Create({ L"]" }));

		rc = gui2.getRect();
		gui2.setPos((Window::Width() - rc.w) / 2, 4);
		gui2.hide();
		m_data->guis.push_back(gui2);

// E
		GUI gui3(GUIStyle::Default);
		gui3.setTitle(L"o͐ݒ");

		String s = L".materialo";
		gui3.addln(L"cb_material", GUICheckBox::Create({ s }));
		gui3.checkBox(L"cb_material").check(0, true);

		s = L"(Aj[Vݒ𔽉f)";
		gui3.addln(L"cb_anim", GUICheckBox::Create({ s }));
		gui3.checkBox(L"cb_anim").check(0, false);
		gui3.checkBox(L"cb_anim").enabled = false;


		rc = gui3.getRect();
		gui3.setPos(Window::Width() - rc.w - 4, 4);
		gui3.hide();
		m_data->guis.push_back(gui3);


		m_data->uiVisibled[0] = true;
		m_data->uiVisibled[1] = false;
		m_data->uiVisibled[2] = false;
		m_data->uiVisibled[3] = true;
	}
	/// <summary>XV</summary>
	void update() override {
		changeScene(L"MainScene");
	}
	/// <summary>`</summary>
	void draw() const override {
		FontAsset(FSM)(L"Please wait a minutes...").drawCenter(100);
	}

};

/// <summary>CV[</summary>
struct MainScene : MyApp::Scene {
	/// <summary></summary>
	void init() override {
		for (int i = 0; i < 4; ++i) {
			m_data->guis[i].show(m_data->uiVisibled[i]);
		}
	}
	/// <summary>XV</summary>
	void update() override {
//// EhbOŃJ
		auto nowPos = Mouse::Pos();

		int mw = Mouse::Wheel();
		if (mw) {
			m_data->camDist += mw * 10.0;
			if (m_data->camDist < 0.0) {
				m_data->camDist = 0.0;
			}
		}

		if (Input::MouseR.pressed) {

			if (m_data->prePos) { // ÂĉĂƂ
								  // 𔽉f
				auto prePos = m_data->prePos.value();
				m_data->curPYR.y = m_data->basePYR.y - (nowPos.x - prePos.x) * 0.01;
				m_data->curPYR.x = m_data->basePYR.x + (nowPos.y - prePos.y) * 0.01;
				m_data->curPYR.x = Clamp<double>(m_data->curPYR.x, -HalfPi, HalfPi);
			}
			else { // VƂ
				m_data->prePos.emplace(nowPos);
			}

		}
		else {
			if (m_data->prePos) { // Ƃ
				m_data->basePYR = m_data->curPYR;
				m_data->prePos.reset();
			}
			else { // NbNĂȂƂ
			}
		}

////

		bool isRot = m_data->guis[2].checkBox(L"cb_rot").checked(0);
		if (isRot) {
			m_data->ang += 0.01;
			m_data->ang += Math::TwoPi / 3600.0;
		}

		m_data->guis[0].text(L"tx_fps").text = ToString(Profiler::FPS());
		m_data->guis[0].text(L"tx_counter").text = ToString(System::FrameCount());

		if (m_data->guis[2].slider(L"sl_amb").hasChanged) {
			auto lv = m_data->guis[2].slider(L"sl_amb").valueInt;
			m_data->guis[2].text(L"tx_amb").text = Format(lv / 100, L".", Pad<int>(lv % 100, {2,'0'}));
			Graphics3D::SetAmbientLight(ColorF(0.01 * (double)lv));
		}

		if (Input::KeyF1.clicked) {
			bool enabled = m_data->guis[3].checkBox(L"cb_anim").enabled;
			m_data->guis[3].checkBox(L"cb_anim").enabled = !enabled;

			String path = FileSystem::ParentPath(FileSystem::ModulePath()) + L"readme.txt";
			System::LaunchFile(path, LaunchVerb::Open);
		}

		// pushedgK[^
		if (m_data->guis[0].button(L"bt_open1").pushed) {
			m_data->uiVisibled[1] = !m_data->uiVisibled[1];
			m_data->guis[1].show(m_data->uiVisibled[1]);
		}
		if (m_data->guis[0].button(L"bt_open2").pushed) {
			m_data->uiVisibled[2] = !m_data->uiVisibled[2];
			m_data->guis[2].show(m_data->uiVisibled[2]);
		}
		if (m_data->guis[0].button(L"bt_open3").pushed) {
			m_data->uiVisibled[3] = !m_data->uiVisibled[3];
			m_data->guis[3].show(m_data->uiVisibled[3]);
		}


		if (Input::KeyF9.clicked) {
			m_data->uiVisibled[0] = !m_data->uiVisibled[0];
			m_data->guis[0].show(m_data->uiVisibled[0]);
		}

		if (m_data->guis[2].checkBox(L"cb_wire").hasChanged) {
			if (m_data->guis[2].checkBox(L"cb_wire").checked(0)) {
				Graphics3D::SetRasterizerState(RasterizerState::WireframeCullNone);
			}
			else {
				Graphics3D::SetRasterizerState(RasterizerState::Default3D);
			}
		}

		if (m_data->guis[2].button(L"bt_bgc").pushed) {
			auto c = Dialog::GetColor();
			if (c) {
				Graphics::SetBackground(c.value());
			}
		}
		if (m_data->guis[0].button(L"bt_clear").pushed
			|| Input::KeyDelete.clicked) {
			this->ClearModel();
		}
		if (m_data->guis[0].button(L"bt_open").pushed) {
			if (auto open = Dialog::GetOpen({ {L"Model(*.mqo)",L"*.mqo"},
				{L"All",L"*.*"} })) {
				OpenMqo(open.value());
			}
		}

		if (Dragdrop::HasItems()) {
			auto paths = Dragdrop::GetFilePaths();
			for (auto path : paths) {
				OpenMqo(path);
			}
		}

		if (m_data->guis[0].button(L"bt_make").pushed) {
			bool result = OutputGpb();
			if (result) {
				m_data->effect.add<Message>(L"o͂܂");
			}
			else {
				m_data->effect.add<Message>(L"s܂");
			}
		}

		for (auto& mi : m_data->mis) {
			if (mi.optIdx.has_value() == false) {
				continue;
			}
			// [VKp
			for (size_t i = 0; i < mi.nodes.size(); ++i) {
				auto& node = mi.nodes[i];
				double ang = (isRot) ? m_data->ang : 0;
				node.motionRot = Quaternion::Yaw(ang);
			}
			mi.ComputeCurCoordinates();
		}

		m_data->effect.update();
	}

	/// <summary>Obh`悷</summary>
	void drawGrid() const {
		Graphics3D::SetRasterizerStateForward(RasterizerState::AntialiasedLine3D);
		double half = 10 * AXISI;
		for (int i = -10; i <= 10; ++i) {
			double p = i * AXISI;
			// OZ
			double endPos = (i == 0) ? 0.0 : half;
			Line3D({ p,   0,half },{ p,0,-endPos }).drawForward(Palette::Silver);
			Line3D({ -half,0,p },   { endPos,0,p }).drawForward(Palette::Silver);
		}

		Line3D({ 0,0,0 }, { half,0,   0 }).drawForward(Palette::Red);
		Line3D({ 0,0,0 }, { 0,   half,0 }).drawForward(Palette::Green);
		Line3D({ 0,0,0 }, { 0,   0,   -half }).drawForward(Palette::Blue);
	}

	/// <summary>`</summary>
	void draw() const override {
		// J씽f
		double dist = m_data->camDist;
		Camera cam;
		cam.fovDegree = 60.0;
		cam.lookat = { 0, 10.0, 0 };
		cam.pos = { 0, 0, -dist };
		cam.up = { 0, 1, 0 };
		Vec3 v = { 0, dist * Sin(m_data->curPYR.x), dist * Cos(m_data->curPYR.x) };
		cam.pos = { v.z * Cos(m_data->curPYR.y), v.y, v.z * Sin(m_data->curPYR.y) };
		cam.pos += cam.lookat;
		Graphics3D::SetCamera(cam);


		if (m_data->guis[2].checkBox(L"cb_axis").checked(0)) {
			this->drawGrid();
		}

		for (auto& mi : m_data->mis) {
			if (mi.optIdx.has_value() == false) {
				continue;
			}
			int idx = mi.optIdx.value();
			if (idx >= m_data->converters.size()) {
				continue;
			}
			const auto& mc = m_data->converters[idx];
			int matNum = mc.mats.size();

			for (size_t i = 0; i < mi.nodes.size(); ++i) {
				if (mc.meshes[i].isEmpty()) {
					//Println(L"̃bV, ", i);
					continue;
				}

				const auto& node = mi.nodes[i];
				Mat4x4 cur = node.GetCurMat();

				for (int j = 0; j < matNum; ++j) {
					if (j >= node.groups.size()) {
						continue;
					}
					const auto& gr = node.groups[j];
					if (gr.num() <= 0) {
						continue;
					}

					const auto& mat = mc.mats[j];
					Vec3 v3(mat.diffuse.r + mat.ambient.r + mat.emission.r,
						mat.diffuse.g + mat.ambient.g + mat.emission.g,
						mat.diffuse.b + mat.ambient.b + mat.emission.b);
					ColorF c(Clamp(v3, 0, 1));

					if (i >= mc.meshes.size()) {
						//Println(L"bVCfbNXG[ ",
						//	i,L" ",j,L" ",mc.meshes.size(),L" ",mc.mats.size());
						continue;
					}

					mc.meshes[i].drawSubset(gr.offset,
						gr.num(),
						cur,
						mc.texs[j],
						c);
				}
			}
		}

	}

	/// <summary>f̓ǂݏoԂNA</summary>
	void ClearModel() {
		ClearPrint();
		m_data->converters.clear();
		m_data->mis.clear();
		m_data->btMake(false);
	}

	/// <summary>.gpbJB</summary>
	void OpenGpb(String inPath) {
		this->ClearModel();

		BinaryReader r(inPath);
		if (r.isOpened() == false) {
			m_data->effect.add<Message>(L"I[vɎs܂");
			return;
		}


		GpbFile gpb;
		gpb.clear();
		//gpb.path = inPath;

		GpbFiler filer;
		auto result = filer.LoadGpb(r, gpb);
		if (result == false) {
			m_data->effect.add<Message>(L"[hɎs܂");
			return;
		}

	};

	/// <summary>.mqot@Cǂݍ݃fpӂ</summary>
	/// <param name="inPath">tt@CpX</param>
	void OpenMqo(String inPath) {
		auto ext = s3d::FileSystem::Extension(inPath).lower();
		if (ext == L"gpb") {
			OpenGpb(inPath);
			return;
		}


		this->ClearModel();

		TextReader r;
		bool result = r.open(inPath);
		if (result == false) {
			m_data->effect.add<Message>(L"I[vɎs܂");
			return;
		}

		ModelConverterGpb mc;

		MqoFile mqo;
		mqo.clear();
		mqo.path = inPath;
		MqoFiler filer;
		result = filer.LoadMqo(r,mqo);
		if (result == false) {
			m_data->effect.add<Message>(L"[hɎs܂");
			return;
		}

		Array<String> options;
		if (m_data->guis[1].checkBox(L"cb_dblface").checked(0)) {
			options.push_back(L"addFaceForDouble");
		}
		double rates[] = { 10.0, 1.0, 0.1 };
		double rate = rates[m_data->guis[0].radioButton(L"rb_deci").checkedItem.value()];

		uint32 cutType = m_data->guis[1].radioButton(L"rb_cutting").checkedItem.value();
		options.push_back(L"cut" + Pad(cutType, { 2,L'0' }));

		result = mc.ApplyMqo(mqo,rate,options);
		if (result) {
			MotionInstance mi = mc.CreateMotionInstance();
			mi.optIdx.emplace(m_data->converters.size());

			m_data->converters.push_back(mc);
			m_data->mis.push_back(mi);

			m_data->effect.add<Message>(L"\܂");
			for (const auto& l : mqo.scene.dirlights) {
				Light dir = Light::Directional(rev_z(l.dir),l.color);
				Graphics3D::SetLight(0, dir);
			}
			m_data->btMake(true);
		}
		else {
			m_data->effect.add<Message>(L"s܂");
		}
	}



	/// <summary>.gpbt@Co͂</summary>
	bool OutputGpb() {
		if (m_data->converters.size() < 1) {
			return false;
		}

		bool isAnim = m_data->guis[3].checkBox(L"cb_anim").checked(0);

		Array<String> options;
		if (isAnim) {
			options.push_back(L"useanim");
		}

		GpbFile gpb;
		bool result = m_data->converters[0].ConvertToGpb(gpb, options);
		if (result == false) {
			return false;
		}


		String modelPath = m_data->converters[0].path;
		String modelDir = FileSystem::ParentPath(modelPath);
		String modelPathBase = modelDir + L"/" + FileSystem::BaseName(modelPath);

		bool isMaterial = m_data->guis[3].checkBox(L"cb_material").checked(0);

		auto outPath = Dialog::GetSave({ { L"gpbt@C(*.gpb)", L"*.gpb" } });
		if (!outPath) {
			return false;
		}

		GpbFiler gpbFiler;
		BinaryWriter w(outPath.value());
		result = gpbFiler.SaveGpb(gpb,w);
		if (result == false) {
			return false;
		}

		if (isMaterial) {
			String s = outPath.value();
			String mtlFileName = s3d::FileSystem::ParentPath(s) + s3d::FileSystem::BaseName(s) + L".material";
			TextWriter tw(mtlFileName, s3d::TextEncoding::UTF8, false);
			result = gpbFiler.SaveMaterial(gpb, tw);
			if (result == false) {
				return false;
			}
		}

		return true;
	}
};

/// <summary>C֐</summary>
void Main() {
	MyApp myApp;
	myApp.add<Startup>(L"Startup");
	myApp.add<MainScene>(L"MainScene");
	while (System::Update()) {
		if (!myApp.updateAndDraw()) {
			break;
		}
	}
}
